from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Directory, String, Boolean, Int

Hint_Cnv_V0_1_0 = CommandToolBuilder(tool="hint_cnv", base_command=["hint", "cnv"], inputs=[ToolInput(tag="in_matrix_file", input_type=File(optional=True), prefix="--matrixfile", doc=InputDocumentation(doc="The matrix compressed file contains single or multiple\nresolutions Hi-C contact matrix files (multi-cool, or\nhic file), resolution should be set via parameter -r;\nor a sparse | dense format matrix file whole genome\nwidely (not suggest when using a high resolution)")), ToolInput(tag="in_ref_dir", input_type=Directory(optional=True), prefix="--refdir", doc=InputDocumentation(doc="the reference directory that downloaded from dropbox\ndropbox. (https://www.dropbox.com/sh/2ufsyu4wvrboxxp/A\nABk5-_Fwy7jdM_t0vIsgYf4a?dl=0.)")), ToolInput(tag="in_map_track", input_type=String(optional=True), prefix="--maptrack", doc=InputDocumentation(doc="Choose which ENCODE mappability track should be used\nfor regression. See more details\nhttp://genome.ucsc.edu/cgi-\nbin/hgTrackUi?db=hg18&g=wgEncodeMapability. DEFAULT:\n50mer")), ToolInput(tag="in_bic_seq", input_type=File(optional=True), prefix="--bicseq", doc=InputDocumentation(doc="/path/to/bicseqDir/")), ToolInput(tag="in_do_iter", input_type=Boolean(optional=True), prefix="--doiter", doc=InputDocumentation(doc="If this switch is on, HiNT will do the iterative\nregression model by removing copy numer variated\nregions, DEFAULT=False")), ToolInput(tag="in_format", input_type=String(optional=True), prefix="--format", doc=InputDocumentation(doc="Format for the output contact matrix, DEFAULT: cooler")), ToolInput(tag="in_enzyme", input_type=String(optional=True), prefix="--enzyme", doc=InputDocumentation(doc="enzyme used for the Hi-C experiments, will be used to\ncalculate enzyme sites")), ToolInput(tag="in_resolution", input_type=Int(optional=True), prefix="--resolution", doc=InputDocumentation(doc="Resolution for the Hi-C contact matrix used for the\nCNV detection, unit: kb, DEFAULT: 50kb")), ToolInput(tag="in_genome", input_type=String(optional=True), prefix="--genome", doc=InputDocumentation(doc="Specify your species, choose form hg38, hg19, and\nmm10. DEFAULT: hg19")), ToolInput(tag="in_outdir", input_type=File(optional=True), prefix="--outdir", doc=InputDocumentation(doc="Path to the output directory, where you want to store\nall the output files, if not set, the current\ndirectory will be used")), ToolInput(tag="in_name", input_type=String(optional=True), prefix="--name", doc=InputDocumentation(doc="Prefix for the result files. If not set, 'NA' will be\nused instead")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="Number of threads for running HiNT-cnv, DEFAULT: 16\n"))], outputs=[ToolOutput(tag="out_outdir", output_type=File(optional=True), selector=InputSelector(input_to_select="in_outdir", type_hint=File()), doc=OutputDocumentation(doc="Path to the output directory, where you want to store\nall the output files, if not set, the current\ndirectory will be used"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Hint_Cnv_V0_1_0().translate("wdl", allow_empty_container=True)

